/*
 * Copyright 1993 Network Computing Devices, Inc.
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name Network Computing Devices, Inc. not be
 * used in advertising or publicity pertaining to distribution of this
 * software without specific, written prior permission.
 *
 * THIS SOFTWARE IS PROVIDED 'AS-IS'.  NETWORK COMPUTING DEVICES, INC.,
 * DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING WITHOUT
 * LIMITATION ALL IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NONINFRINGEMENT.  IN NO EVENT SHALL NETWORK
 * COMPUTING DEVICES, INC., BE LIABLE FOR ANY DAMAGES WHATSOEVER, INCLUDING
 * SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES, INCLUDING LOSS OF USE, DATA,
 * OR PROFITS, EVEN IF ADVISED OF THE POSSIBILITY THEREOF, AND REGARDLESS OF
 * WHETHER IN AN ACTION IN CONTRACT, TORT OR NEGLIGENCE, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * $NCDId: @(#)fileutil.c,v 1.4 1993/02/26 17:49:04 jim Exp $
 */

/*
 * sound file reading util functions
 */

#include	<stdio.h>
#include	<strings.h>
#include	<audio/fileutil.h>

extern char *malloc();

#if NeedFunctionPrototypes
unsigned short FileSwapS (unsigned short us)
#else
unsigned short 
FileSwapS(us)
    unsigned short us;
#endif
{
    return ((us >> 8) | (us << 8)) & 0xffff;
}

unsigned long
FileSwapL(ul)
    unsigned long ul;
{
    return (ul >> 24) | ((ul >> 8) & 0xff00) | ((ul << 8) & 0xff0000) |
	(ul << 24);
}

unsigned short
FileReadS(fp, swapit)
    FILE       *fp;
    int         swapit;
{
    unsigned short us;

    fread(&us, 2, 1, fp);
    if (swapit)
	us = FileSwapS(us);
    return us;
}

unsigned long
FileReadL(fp, swapit)
    FILE       *fp;
    int         swapit;
{
    unsigned long ul;

    fread(&ul, 4, 1, fp);
    if (swapit)
	ul = FileSwapL(ul);
    return ul;
}

#if NeedFunctionPrototypes
void FileWriteS (unsigned short us, FILE *fp, int swapit)
#else
void
FileWriteS(us, fp, swapit)
    unsigned short us;
    FILE       *fp;
    int         swapit;
#endif
{
    if (swapit)
	us = FileSwapS(us);
    fwrite(&us, 2, 1, fp);
}

void
FileWriteL(ul, fp, swapit)
    unsigned long ul;
    FILE       *fp;
    int         swapit;
{
    if (swapit)
	ul = FileSwapL(ul);
    fwrite(&ul, 4, 1, fp);
}

char       *
FileCommentFromFilename(fname)
    _FileConst char *fname;
{
    _FileConst char *f;
    char       *t;

    /* ignore piped files */
    if (strcmp(fname, "-")) {
	f = rindex(fname, '/');
	if (!f)
	    f = fname;
	else
	    f++;
	t = (char *) malloc(strlen(f) + 1);
	if (t) {
	    strcpy(t, f);
	}
    } else {
	t = (char *) malloc(1);
	if (t) {
	    *t = '\0';
	}
    }
    return t;
}
